Package java.lang

## Class StackTraceElement

- java.lang.Object
- - java.lang.StackTraceElement

- All Implemented Interfaces:
    `Serializable`

      public final class StackTraceElement
      extends Object
      implements Serializable

  An element in a stack trace. Each element represents a single stack frame. All stack frames except for the one at the top of the stack represent a method invocation. The frame at the top of the stack represents the execution point at which the stack trace was generated. Typically, this is the point at which the throwable corresponding to the stack trace was created.
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `StackTraceElement()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `equals​(Object obj)` | Returns true if the specified object is another `StackTraceElement` instance representing the same execution point as this instance.
    `String` | `getClassName()` | Returns the fully qualified name of the class containing the execution point represented by this stack trace element.
    `String` | `getFileName()` | Returns the name of the source file containing the execution point represented by this stack trace element.
    `int` | `getLineNumber()` | Returns the line number of the source line containing the execution point represented by this stack trace element.
    `String` | `getMethodName()` | Returns the name of the method containing the execution point represented by this stack trace element.
    `int` | `hashCode()` | Returns a hash code value for this stack trace element.
    `String` | `toString()` | Returns a string representation of this stack trace element.

    - ### Methods inherited from class java.lang.Object

      `clone, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### StackTraceElement

          public StackTraceElement()

  - ### Method Detail

    - #### equals

          public boolean equals​(@Nullable
                                Object obj)

      Returns true if the specified object is another `StackTraceElement` instance representing the same execution point as this instance. Two stack trace elements `a` and `b` are equal if and only if:

               equals(a.getFileName(), b.getFileName()) &&
               a.getLineNumber() == b.getLineNumber()) &&
               equals(a.getClassName(), b.getClassName()) &&
               equals(a.getMethodName(), b.getMethodName())

      Overrides:
        `equals` in class `Object`
      Parameters:
        `obj` - the object to be compared with this stack trace element.
      Returns:
        true if the specified object is another `StackTraceElement` instance representing the same execution point as this instance.
      See Also:
        `Object.hashCode()`, `HashMap`

    - #### getClassName

          public String getClassName()

      Returns the fully qualified name of the class containing the execution point represented by this stack trace element.
      Returns:
        the fully qualified name of the `Class` containing the execution point represented by this stack trace element.

    - #### getFileName

          @Nullable
          public String getFileName()

      Returns the name of the source file containing the execution point represented by this stack trace element. Generally, this corresponds to the `SourceFile` attribute of the relevant `class` file (as per The Java Virtual Machine Specification, Section 4.7.7). In some systems, the name may refer to some source code unit other than a file, such as an entry in source repository.
      Returns:
        the name of the file containing the execution point represented by this stack trace element, or `null` if this information is unavailable.

    - #### getLineNumber

          public int getLineNumber()

      Returns the line number of the source line containing the execution point represented by this stack trace element. Generally, this is derived from the `LineNumberTable` attribute of the relevant `class` file (as per The Java Virtual Machine Specification, Section 4.7.8).
      Returns:
        the line number of the source line containing the execution point represented by this stack trace element, or a negative number if this information is unavailable.

    - #### getMethodName

          public String getMethodName()

      Returns the name of the method containing the execution point represented by this stack trace element. If the execution point is contained in an instance or class initializer, this method will return the appropriate special method name, `<init>` or `<clinit>`, as per Section 3.9 of The Java Virtual Machine Specification.
      Returns:
        the name of the method containing the execution point represented by this stack trace element.

    - #### hashCode

          public int hashCode()

      Returns a hash code value for this stack trace element.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        a hash code value for this object.
      See Also:
        `Object.equals(java.lang.Object)`, `System.identityHashCode(java.lang.Object)`

    - #### toString

          public String toString()

      Returns a string representation of this stack trace element. The format of this string depends on the implementation.
      Overrides:
        `toString` in class `Object`
      Returns:
        a string representation of the object.